/*
 *   Copyright Institute of Communication and Computer Systems (ICCS)
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

/**
 * @file   parse_env.h
 * @author Ioannis Koutras (joko@microlab.ntua.gr)
 * @date   February 2014
 * @brief  Function to parse environment variables
 */

#ifndef DEALY_PARSE_ENV_H_
#define DEALY_PARSE_ENV_H_
#include <dmmlib/allocator.h>

/** Parses various allocator-related enviroment variables. */
void parse_env(allocator_t *allocator);

#endif /* DEALY_PARSE_ENV_H_ */
