/*
 *   Copyright Institute of Communication and Computer Systems (ICCS)
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

/**
 * \file   slab/free.c
 * \author Iraklis Anagnostopoulos (iraklis@microlab.ntua.gr)
 * \date   March 2014
 * \brief  free() implementation for slab raw blocks
 */

#include "slab.h"

void slab_free(slab_rb_t *slab_raw_block, void *ptr) {
    slab_block_header_t *block = (slab_block_header_t *) ptr;
    if(slab_raw_block->fl_tail != NULL) {
        slab_raw_block->fl_tail->pointers.sle_next = block;
        block->pointers.sle_next = NULL;
    } else {
        SLIST_INSERT_HEAD(&slab_raw_block->fl_head, block, pointers);
    }
    slab_raw_block->fl_tail = block;
}
