#include <dmmlib/lists.h>
#include "tls_allocator.h"

void push_to_destructed_list(void) {
    while(__sync_bool_compare_and_swap(&destructed_list.lock, STATE_UNLOCKED,
                STATE_LOCKED) != STATE_UNLOCKED){};
    SLIST_INSERT_HEAD(&destructed_list.head, tls_allocator, pointer);
    destructed_list.lock = STATE_UNLOCKED;
}

void get_tls_allocator(void) {
    if(__builtin_expect(!!(tls_allocator == NULL), 0)) {
        if(((__sync_bool_compare_and_swap(&destructed_list.lock, STATE_UNLOCKED,
                            STATE_LOCKED) != STATE_UNLOCKED)) == 0) {
            tls_allocator = SLIST_FIRST(&destructed_list.head);
            if(tls_allocator == NULL) {
                tls_allocator = initialize_allocator();
            } else {
                SLIST_REMOVE_HEAD(&destructed_list.head, pointer);
            }
            destructed_list.lock = STATE_UNLOCKED;
        } else {
            tls_allocator = initialize_allocator();
        }
        pthread_key_create(&destruction_key,
                (void (*)(void *)) push_to_destructed_list);
        pthread_setspecific(destruction_key, (void *) 1);
    }
}
